import { ConfigOptions } from "../config/standardize.js";
import { ValueOf } from "../lib/types";
import { InterpretedPayload } from "../payload/interpret.js";
export declare const status: {
    readonly SUCCESS: "success";
    readonly FAILURE: "failure";
};
export declare type Status = ValueOf<typeof status>;
export declare function getOutcome(result: boolean): Status;
declare type Maybe<T> = T | undefined;
export declare function runPipeline(options: ConfigOptions & {
    autoExitAfterFailure: boolean;
}): Promise<Maybe<InterpretedPayload>>;
export {};
