import { Logger } from "@nodesecure/scanner";
import { ReporterTarget } from "../nodesecurerc.js";
import { InterpretedPayload } from "../payload/index.js";
export declare type Reporter = {
    type: ReporterTarget;
    report: (payload: InterpretedPayload) => Promise<void>;
};
/**
 * This report has nothing to do with console or html reporters. This function
 * is used to print out @nodesecure/scanner's events on project analysis.
 * Consequently, this process is before and independent of the process of
 * reporting either in console or in a .html file.
 * @param logger
 */
export declare function reportScannerLoggerEvents(logger: Logger): void;
